diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/regular-wifi-mac.h ns-3.35/src/wifi/model/regular-wifi-mac.h
--- ns-3.34/src/wifi/model/regular-wifi-mac.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/regular-wifi-mac.h	2021-10-01 13:26:48.000000000 -0700
@@ -35,6 +35,7 @@
 class ExtendedCapabilities;
 class FrameExchangeManager;
 class WifiPsdu;
+class WifiMacQueue;
 enum WifiTxTimerReason : uint8_t;
 
 typedef std::unordered_map <uint16_t /* staId */, Ptr<WifiPsdu> /* PSDU */> WifiPsduMap;
@@ -123,6 +124,50 @@
    * \return a smart pointer to a QosTxop
    */
   Ptr<QosTxop> GetQosTxop (uint8_t tid) const;
+  /**
+   * Get the wifi MAC queue of the (Qos)Txop associated with the given AC.
+   *
+   * \param ac the given Access Category
+   * \return the wifi MAC queue of the (Qos)Txop associated with the given AC
+   */
+  virtual Ptr<WifiMacQueue> GetTxopQueue (AcIndex ac) const;
+
+  /**
+   * Return whether the device supports QoS.
+   *
+   * \return true if QoS is supported, false otherwise
+   */
+  bool GetQosSupported () const;
+  /**
+   * Return whether the device supports ERP.
+   *
+   * \return true if ERP is supported, false otherwise
+   */
+  bool GetErpSupported () const;
+  /**
+   * Return whether the device supports DSSS.
+   *
+   * \return true if DSSS is supported, false otherwise
+   */
+  bool GetDsssSupported () const;
+  /**
+   * Return whether the device supports HT.
+   *
+   * \return true if HT is supported, false otherwise
+   */
+  bool GetHtSupported () const;
+  /**
+   * Return whether the device supports VHT.
+   *
+   * \return true if VHT is supported, false otherwise
+   */
+  bool GetVhtSupported () const;
+  /**
+   * Return whether the device supports HE.
+   *
+   * \return true if HE is supported, false otherwise
+   */
+  bool GetHeSupported () const;
 
   /**
    * Return the extended capabilities of the device.
@@ -149,6 +194,21 @@
    */
   HeCapabilities GetHeCapabilities (void) const;
 
+  /**
+   * Return the maximum A-MPDU size of the given Access Category.
+   *
+   * \param ac Access Category index
+   * \return the maximum A-MPDU size
+   */
+  uint32_t GetMaxAmpduSize (AcIndex ac) const;
+  /**
+   * Return the maximum A-MSDU size of the given Access Category.
+   *
+   * \param ac Access Category index
+   * \return the maximum A-MSDU size
+   */
+  uint16_t GetMaxAmsduSize (AcIndex ac) const;
+
 protected:
   void DoInitialize () override;
   void DoDispose () override;
@@ -252,12 +312,6 @@
    * \param enable whether QoS is supported
    */
   virtual void SetQosSupported (bool enable);
-  /**
-   * Return whether the device supports QoS.
-   *
-   * \return true if QoS is supported, false otherwise
-   */
-  bool GetQosSupported () const;
 
   /**
    * Create a Frame Exchange Manager depending on the supported version
@@ -266,31 +320,11 @@
   void SetupFrameExchangeManager (void);
 
   /**
-   * Return whether the device supports HT.
-   *
-   * \return true if HT is supported, false otherwise
-   */
-  bool GetHtSupported () const;
-
-  /**
-   * Return whether the device supports VHT.
-   *
-   * \return true if VHT is supported, false otherwise
-   */
-  bool GetVhtSupported () const;
-
-  /**
    * Enable or disable ERP support for the device.
    *
    * \param enable whether ERP is supported
    */
   void SetErpSupported (bool enable);
-  /**
-   * Return whether the device supports ERP.
-   *
-   * \return true if ERP is supported, false otherwise
-   */
-  bool GetErpSupported () const;
 
   /**
    * Enable or disable DSSS support for the device.
@@ -298,19 +332,6 @@
    * \param enable whether DSSS is supported
    */
   void SetDsssSupported (bool enable);
-  /**
-   * Return whether the device supports DSSS.
-   *
-   * \return true if DSSS is supported, false otherwise
-   */
-  bool GetDsssSupported () const;
-
-  /**
-   * Return whether the device supports HE.
-   *
-   * \return true if HE is supported, false otherwise
-   */
-  bool GetHeSupported () const;
 
 private:
   /// type conversion operator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/spectrum-wifi-phy.cc ns-3.35/src/wifi/model/spectrum-wifi-phy.cc
--- ns-3.34/src/wifi/model/spectrum-wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/spectrum-wifi-phy.cc	2021-10-01 13:26:48.000000000 -0700
@@ -304,10 +304,9 @@
   if ((channelWidth == 5) || (channelWidth == 10))
     {
       WifiSpectrumBand filteredBand = GetBand (channelWidth);
-      Ptr<SpectrumValue> filter = WifiSpectrumValueHelper::CreateRfFilter (GetFrequency (), channelWidth, GetBandBandwidth (), GetGuardBandwidth (channelWidth), filteredBand);
-      SpectrumValue filteredSignal = (*filter) * (*receivedSignalPsd);
-      NS_LOG_DEBUG ("Signal power received (watts) before antenna gain: " << Integral (filteredSignal));
-      double rxPowerPerBandW = Integral (filteredSignal) * DbToRatio (GetRxGain ());
+      double rxPowerPerBandW = WifiSpectrumValueHelper::GetBandPowerW (receivedSignalPsd, filteredBand);
+      NS_LOG_DEBUG ("Signal power received (watts) before antenna gain: " << rxPowerPerBandW);
+      rxPowerPerBandW *= DbToRatio (GetRxGain ());
       totalRxPowerW += rxPowerPerBandW;
       rxPowerW.insert ({filteredBand, rxPowerPerBandW});
       NS_LOG_DEBUG ("Signal power received after antenna gain for " << channelWidth << " MHz channel: " << rxPowerPerBandW << " W (" << WToDbm (rxPowerPerBandW) << " dBm)");
@@ -319,10 +318,9 @@
         {
           NS_ASSERT (channelWidth >= bw);
           WifiSpectrumBand filteredBand = GetBand (bw, i);
-          Ptr<SpectrumValue> filter = WifiSpectrumValueHelper::CreateRfFilter (GetFrequency (), channelWidth, GetBandBandwidth (), GetGuardBandwidth (channelWidth), filteredBand);
-          SpectrumValue filteredSignal = (*filter) * (*receivedSignalPsd);
-          NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for " << bw << " MHz channel band " << +i << ": " << Integral (filteredSignal));
-          double rxPowerPerBandW = Integral (filteredSignal) * DbToRatio (GetRxGain ());
+          double rxPowerPerBandW = WifiSpectrumValueHelper::GetBandPowerW (receivedSignalPsd, filteredBand);
+          NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for " << bw << " MHz channel band " << +i << ": " << rxPowerPerBandW);
+          rxPowerPerBandW *= DbToRatio (GetRxGain ());
           rxPowerW.insert ({filteredBand, rxPowerPerBandW});
           NS_LOG_DEBUG ("Signal power received after antenna gain for " << bw << " MHz channel band " << +i << ": " << rxPowerPerBandW << " W (" << WToDbm (rxPowerPerBandW) << " dBm)");
         }
@@ -332,10 +330,9 @@
   for (uint8_t i = 0; i < (channelWidth / 20); i++)
     {
       WifiSpectrumBand filteredBand = GetBand (20, i);
-      Ptr<SpectrumValue> filter = WifiSpectrumValueHelper::CreateRfFilter (GetFrequency (), channelWidth, GetBandBandwidth (), GetGuardBandwidth (channelWidth), filteredBand);
-      SpectrumValue filteredSignal = (*filter) * (*receivedSignalPsd);
-      NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for 20 MHz channel band " << +i << ": " << Integral (filteredSignal));
-      double rxPowerPerBandW = Integral (filteredSignal) * DbToRatio (GetRxGain ());
+      double rxPowerPerBandW = WifiSpectrumValueHelper::GetBandPowerW (receivedSignalPsd, filteredBand);
+      NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for 20 MHz channel band " << +i << ": " << rxPowerPerBandW);
+      rxPowerPerBandW *= DbToRatio (GetRxGain ());
       totalRxPowerW += rxPowerPerBandW;
       rxPowerW.insert ({filteredBand, rxPowerPerBandW});
       NS_LOG_DEBUG ("Signal power received after antenna gain for 20 MHz channel band " << +i << ": " << rxPowerPerBandW << " W (" << WToDbm (rxPowerPerBandW) << " dBm)");
@@ -346,10 +343,9 @@
       NS_ASSERT (!m_ruBands[channelWidth].empty ());
       for (const auto& bandRuPair : m_ruBands[channelWidth])
         {
-          Ptr<SpectrumValue> filter = WifiSpectrumValueHelper::CreateRfFilter (GetFrequency (), channelWidth, GetBandBandwidth (), GetGuardBandwidth (channelWidth), bandRuPair.first);
-          SpectrumValue filteredSignal = (*filter) * (*receivedSignalPsd);
-          NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for RU with type " << bandRuPair.second.GetRuType () << " and index " << bandRuPair.second.GetIndex () << " -> (" << bandRuPair.first.first << "; " << bandRuPair.first.second <<  "): " << Integral (filteredSignal));
-          double rxPowerPerBandW = Integral (filteredSignal) * DbToRatio (GetRxGain ());
+          double rxPowerPerBandW = WifiSpectrumValueHelper::GetBandPowerW (receivedSignalPsd, bandRuPair.first);
+          NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for RU with type " << bandRuPair.second.GetRuType () << " and index " << bandRuPair.second.GetIndex () << " -> (" << bandRuPair.first.first << "; " << bandRuPair.first.second <<  "): " << rxPowerPerBandW);
+          rxPowerPerBandW *= DbToRatio (GetRxGain ());
           NS_LOG_DEBUG ("Signal power received after antenna gain for RU with type " << bandRuPair.second.GetRuType () << " and index " << bandRuPair.second.GetIndex () << " -> (" << bandRuPair.first.first << "; " << bandRuPair.first.second <<  "): " << rxPowerPerBandW << " W (" << WToDbm (rxPowerPerBandW) << " dBm)");
           rxPowerW.insert ({bandRuPair.first, rxPowerPerBandW});
         }
@@ -383,6 +379,9 @@
   if (totalRxPowerW < DbmToW (GetRxSensitivity ()) * (txWidth / 20.0))
     {
       NS_LOG_INFO ("Received signal too weak to process: " << WToDbm (totalRxPowerW) << " dBm");
+      m_interference.Add (wifiRxParams->ppdu, wifiRxParams->ppdu->GetTxVector (), rxDuration,
+                          rxPowerW);
+      SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (wifiRxParams->ppdu));
       return;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/sta-wifi-mac.cc ns-3.35/src/wifi/model/sta-wifi-mac.cc
--- ns-3.34/src/wifi/model/sta-wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/sta-wifi-mac.cc	2021-10-01 13:26:48.000000000 -0700
@@ -821,6 +821,19 @@
                 }
             }
         }
+
+      MuEdcaParameterSet muEdcaParameters = beacon.GetMuEdcaParameterSet ();
+      if (muEdcaParameters.IsPresent ())
+        {
+          SetMuEdcaParameters (AC_BE, muEdcaParameters.GetMuCwMin (AC_BE), muEdcaParameters.GetMuCwMax (AC_BE),
+                               muEdcaParameters.GetMuAifsn (AC_BE), muEdcaParameters.GetMuEdcaTimer (AC_BE));
+          SetMuEdcaParameters (AC_BK, muEdcaParameters.GetMuCwMin (AC_BK), muEdcaParameters.GetMuCwMax (AC_BK),
+                               muEdcaParameters.GetMuAifsn (AC_BK), muEdcaParameters.GetMuEdcaTimer (AC_BK));
+          SetMuEdcaParameters (AC_VI, muEdcaParameters.GetMuCwMin (AC_VI), muEdcaParameters.GetMuCwMax (AC_VI),
+                               muEdcaParameters.GetMuAifsn (AC_VI), muEdcaParameters.GetMuEdcaTimer (AC_VI));
+          SetMuEdcaParameters (AC_VO, muEdcaParameters.GetMuCwMin (AC_VO), muEdcaParameters.GetMuCwMax (AC_VO),
+                               muEdcaParameters.GetMuAifsn (AC_VO), muEdcaParameters.GetMuEdcaTimer (AC_VO));
+        }
     }
   m_stationManager->SetShortPreambleEnabled (isShortPreambleEnabled);
   m_stationManager->SetShortSlotTimeEnabled (capabilities.IsShortSlotTime ());
@@ -981,6 +994,19 @@
           HeOperation heOperation = assocResp.GetHeOperation ();
           GetHeConfiguration ()->SetAttribute ("BssColor", UintegerValue (heOperation.GetBssColor ()));
         }
+
+      MuEdcaParameterSet muEdcaParameters = assocResp.GetMuEdcaParameterSet ();
+      if (muEdcaParameters.IsPresent ())
+        {
+          SetMuEdcaParameters (AC_BE, muEdcaParameters.GetMuCwMin (AC_BE), muEdcaParameters.GetMuCwMax (AC_BE),
+                               muEdcaParameters.GetMuAifsn (AC_BE), muEdcaParameters.GetMuEdcaTimer (AC_BE));
+          SetMuEdcaParameters (AC_BK, muEdcaParameters.GetMuCwMin (AC_BK), muEdcaParameters.GetMuCwMax (AC_BK),
+                               muEdcaParameters.GetMuAifsn (AC_BK), muEdcaParameters.GetMuEdcaTimer (AC_BK));
+          SetMuEdcaParameters (AC_VI, muEdcaParameters.GetMuCwMin (AC_VI), muEdcaParameters.GetMuCwMax (AC_VI),
+                               muEdcaParameters.GetMuAifsn (AC_VI), muEdcaParameters.GetMuEdcaTimer (AC_VI));
+          SetMuEdcaParameters (AC_VO, muEdcaParameters.GetMuCwMin (AC_VO), muEdcaParameters.GetMuCwMax (AC_VO),
+                               muEdcaParameters.GetMuAifsn (AC_VO), muEdcaParameters.GetMuEdcaTimer (AC_VO));
+        }
     }
   for (const auto & mode : m_phy->GetModeList ())
     {
@@ -1084,7 +1110,7 @@
 void
 StaWifiMac::SetEdcaParameters (AcIndex ac, uint32_t cwMin, uint32_t cwMax, uint8_t aifsn, Time txopLimit)
 {
-  Ptr<QosTxop> edca = m_edca.find (ac)->second;
+  Ptr<QosTxop> edca = GetQosTxop (ac);
   edca->SetMinCw (cwMin);
   edca->SetMaxCw (cwMax);
   edca->SetAifsn (aifsn);
@@ -1092,6 +1118,16 @@
 }
 
 void
+StaWifiMac::SetMuEdcaParameters (AcIndex ac, uint16_t cwMin, uint16_t cwMax, uint8_t aifsn, Time muEdcaTimer)
+{
+  Ptr<QosTxop> edca = GetQosTxop (ac);
+  edca->SetMuCwMin (cwMin);
+  edca->SetMuCwMax (cwMax);
+  edca->SetMuAifsn (aifsn);
+  edca->SetMuEdcaTimer (muEdcaTimer);
+}
+
+void
 StaWifiMac::PhyCapabilitiesChanged (void)
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/sta-wifi-mac.h ns-3.35/src/wifi/model/sta-wifi-mac.h
--- ns-3.34/src/wifi/model/sta-wifi-mac.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/sta-wifi-mac.h	2021-10-01 13:26:48.000000000 -0700
@@ -291,6 +291,16 @@
    */
   void SetEdcaParameters (AcIndex ac, uint32_t cwMin, uint32_t cwMax, uint8_t aifsn, Time txopLimit);
   /**
+   * Set the MU EDCA parameters.
+   *
+   * \param ac the Access Category
+   * \param cwMin the minimum contention window size
+   * \param cwMax the maximum contention window size
+   * \param aifsn the number of slots that make up an AIFS
+   * \param muEdcaTimer the MU EDCA timer
+   */
+  void SetMuEdcaParameters (AcIndex ac, uint16_t cwMin, uint16_t cwMax, uint8_t aifsn, Time muEdcaTimer);
+  /**
    * Return the Capability information of the current STA.
    *
    * \return the Capability information that we support
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/table-based-error-rate-model.cc ns-3.35/src/wifi/model/table-based-error-rate-model.cc
--- ns-3.34/src/wifi/model/table-based-error-rate-model.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/table-based-error-rate-model.cc	2021-10-01 13:26:48.000000000 -0700
@@ -132,7 +132,7 @@
             }
         }
     }
-  else if (mode.GetModulationClass () == WIFI_MOD_CLASS_HT || mode.GetModulationClass () == WIFI_MOD_CLASS_VHT || mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
+  else if (mode.GetModulationClass () >= WIFI_MOD_CLASS_HT)
     {
       mcs = mode.GetMcsValue ();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/txop.cc ns-3.35/src/wifi/model/txop.cc
--- ns-3.34/src/wifi/model/txop.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/txop.cc	2021-10-01 13:26:48.000000000 -0700
@@ -25,14 +25,13 @@
 #include "ns3/socket.h"
 #include "txop.h"
 #include "channel-access-manager.h"
-#include "wifi-mac.h"
+#include "regular-wifi-mac.h"
 #include "wifi-mac-queue.h"
 #include "mac-tx-middle.h"
-#include "wifi-remote-station-manager.h"
 #include "wifi-mac-trailer.h"
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT if (m_stationManager != 0 && m_stationManager->GetMac () != 0) { std::clog << "[mac=" << m_stationManager->GetMac ()->GetAddress () << "] "; }
+#define NS_LOG_APPEND_CONTEXT if (m_mac != 0) { std::clog << "[mac=" << m_mac->GetAddress () << "] "; }
 
 namespace ns3 {
 
@@ -84,7 +83,13 @@
 }
 
 Txop::Txop ()
+  : Txop (CreateObject<WifiMacQueue> (AC_BE_NQOS))
+{
+}
+
+Txop::Txop (Ptr<WifiMacQueue> queue)
   : m_channelAccessManager (0),
+    m_queue (queue),
     m_cwMin (0),
     m_cwMax (0),
     m_cw (0),
@@ -94,7 +99,6 @@
     m_backoffStart (Seconds (0.0))
 {
   NS_LOG_FUNCTION (this);
-  m_queue = CreateObject<WifiMacQueue> ();
   m_rng = CreateObject<UniformRandomVariable> ();
 }
 
@@ -108,7 +112,7 @@
 {
   NS_LOG_FUNCTION (this);
   m_queue = 0;
-  m_stationManager = 0;
+  m_mac = 0;
   m_rng = 0;
   m_txMiddle = 0;
   m_channelAccessManager = 0;
@@ -129,10 +133,10 @@
 }
 
 void
-Txop::SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager)
+Txop::SetWifiMac (const Ptr<RegularWifiMac> mac)
 {
-  NS_LOG_FUNCTION (this << remoteManager);
-  m_stationManager = remoteManager;
+  NS_LOG_FUNCTION (this << mac);
+  m_mac = mac;
 }
 
 void
@@ -187,7 +191,7 @@
 Txop::ResetCw (void)
 {
   NS_LOG_FUNCTION (this);
-  m_cw = m_cwMin;
+  m_cw = GetMinCw ();
   m_cwTrace = m_cw;
 }
 
@@ -196,7 +200,9 @@
 {
   NS_LOG_FUNCTION (this);
   //see 802.11-2012, section 9.19.2.5
-  m_cw = std::min ( 2 * (m_cw + 1) - 1, m_cwMax);
+  m_cw = std::min ( 2 * (m_cw + 1) - 1, GetMaxCw ());
+  // if the MU EDCA timer is running, CW cannot be less than MU CW min
+  m_cw = std::max (m_cw, GetMinCw ());
   m_cwTrace = m_cw;
 }
 
@@ -376,14 +382,6 @@
 }
 
 void
-Txop::NotifyInternalCollision (void)
-{
-  NS_LOG_FUNCTION (this);
-  GenerateBackoff ();
-  StartAccessIfNeeded ();
-}
-
-void
 Txop::NotifyChannelSwitching (void)
 {
   NS_LOG_FUNCTION (this);
@@ -423,10 +421,4 @@
   return false;
 }
 
-AcIndex
-Txop::GetAccessCategory (void) const
-{
-  return AC_BE_NQOS;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/txop.h ns-3.35/src/wifi/model/txop.h
--- ns-3.34/src/wifi/model/txop.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/txop.h	2021-10-01 13:26:48.000000000 -0700
@@ -34,9 +34,8 @@
 class WifiMacQueueItem;
 class UniformRandomVariable;
 class CtrlBAckResponseHeader;
-class WifiRemoteStationManager;
+class RegularWifiMac;
 enum WifiMacDropReason : uint8_t;  // opaque enum declaration
-enum AcIndex : uint8_t;
 
 /**
  * \brief Handle packet fragmentation and retransmissions
@@ -45,9 +44,9 @@
  *
  * This class implements the packet fragmentation and
  * retransmission policy for data and management frames.
- * It uses the ns3::MacLow and ns3::ChannelAccessManager helper
- * classes to respectively send packets and decide when
- * to send them. Packets are stored in a ns3::WifiMacQueue
+ * It uses the ns3::ChannelAccessManager helper
+ * class to decide when to send a packet.
+ * Packets are stored in a ns3::WifiMacQueue
  * until they can be sent.
  *
  * The policy currently implemented uses a simple fragmentation
@@ -65,10 +64,15 @@
 class Txop : public Object
 {
 public:
-  /// allow MacLowTransmissionListener class access
-  friend class MacLowTransmissionListener;
-
   Txop ();
+
+  /**
+   * Constructor
+   *
+   * \param queue the wifi MAC queue
+   */
+  Txop (Ptr<WifiMacQueue> queue);
+
   virtual ~Txop ();
 
   /**
@@ -98,12 +102,6 @@
    * \returns true if QoS TXOP.
    */
   virtual bool IsQosTxop () const;
-  /**
-   * Get the access category.
-   *
-   * \return the access category.
-   */
-  virtual AcIndex GetAccessCategory (void) const;
 
   /**
    * Set ChannelAccessManager this Txop is associated to.
@@ -112,11 +110,11 @@
    */
   void SetChannelAccessManager (const Ptr<ChannelAccessManager> manager);
   /**
-   * Set WifiRemoteStationsManager this Txop is associated to.
+   * Set the wifi MAC this Txop is associated to.
    *
-   * \param remoteManager WifiRemoteStationManager to associate.
+   * \param mac associated wifi MAC
    */
-  virtual void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager);
+  virtual void SetWifiMac (const Ptr<RegularWifiMac> mac);
   /**
    * Set MacTxMiddle this Txop is associated to.
    *
@@ -166,19 +164,19 @@
    *
    * \return the minimum contention window size.
    */
-  uint32_t GetMinCw (void) const;
+  virtual uint32_t GetMinCw (void) const;
   /**
    * Return the maximum contention window size.
    *
    * \return the maximum contention window size.
    */
-  uint32_t GetMaxCw (void) const;
+  virtual uint32_t GetMaxCw (void) const;
   /**
    * Return the number of slots that make up an AIFS.
    *
    * \return the number of slots that make up an AIFS.
    */
-  uint8_t GetAifsn (void) const;
+  virtual uint8_t GetAifsn (void) const;
   /**
    * Return the TXOP limit.
    *
@@ -280,10 +278,6 @@
    * Notify that access request has been received.
    */
   virtual void NotifyAccessRequested (void);
-  /**
-   * Notify the Txop that internal collision has occurred.
-   */
-  virtual void NotifyInternalCollision (void);
 
   /**
    * Check if the Txop has frames to transmit.
@@ -332,7 +326,7 @@
   DroppedMpdu m_droppedMpduCallback;                //!< the dropped MPDU callback
   Ptr<WifiMacQueue> m_queue;                        //!< the wifi MAC queue
   Ptr<MacTxMiddle> m_txMiddle;                      //!< the MacTxMiddle
-  Ptr<WifiRemoteStationManager> m_stationManager;   //!< the wifi remote station manager
+  Ptr<RegularWifiMac> m_mac;                        //!< the wifi MAC
   Ptr<UniformRandomVariable> m_rng;                 //!< the random stream
 
   uint32_t m_cwMin;              //!< the minimum contention window
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-default-ack-manager.cc ns-3.35/src/wifi/model/wifi-default-ack-manager.cc
--- ns-3.34/src/wifi/model/wifi-default-ack-manager.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-default-ack-manager.cc	2021-10-01 13:26:48.000000000 -0700
@@ -152,7 +152,7 @@
   if (m_baThreshold > 0
       && GetMaxDistFromStartingSeq (mpdu, txParams) < m_baThreshold * edca->GetBaBufferSize (receiver, tid)
       && (edca->GetWifiMacQueue ()->GetNPackets (tid, receiver)
-         + edca->GetBaManager ()->GetRetransmitQueue ()->GetNPackets (tid, receiver) > 1)
+          - edca->GetBaManager ()->GetNBufferedPackets (receiver, tid) > 1)
       && !(edca->GetTxopLimit ().IsStrictlyPositive ()
            && edca->GetRemainingTxop () == edca->GetTxopLimit ()
            && !(txParams.m_protection && txParams.m_protection->method == WifiProtection::RTS_CTS)))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-information-element.h ns-3.35/src/wifi/model/wifi-information-element.h
--- ns-3.34/src/wifi/model/wifi-information-element.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-information-element.h	2021-10-01 13:26:48.000000000 -0700
@@ -190,6 +190,8 @@
 
 #define IE_EXT_HE_CAPABILITIES                  ((WifiInformationElementId)35)
 #define IE_EXT_HE_OPERATION                     ((WifiInformationElementId)36)
+#define IE_EXT_UORA_PARAMETER_SET               ((WifiInformationElementId)37)
+#define IE_EXT_MU_EDCA_PARAMETER_SET            ((WifiInformationElementId)38)
 
 /**
  * \brief Information element, as defined in 802.11-2007 standard
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-mac.cc ns-3.35/src/wifi/model/wifi-mac.cc
--- ns-3.34/src/wifi/model/wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-mac.cc	2021-10-01 13:26:48.000000000 -0700
@@ -174,6 +174,9 @@
       dcf->SetAifsn (2);
       dcf->SetTxopLimit (MicroSeconds (0));
       break;
+    case AC_BEACON:
+      // done by ApWifiMac
+      break;
     case AC_UNDEF:
       NS_FATAL_ERROR ("I don't know what to do with this");
       break;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-mac.h ns-3.35/src/wifi/model/wifi-mac.h
--- ns-3.34/src/wifi/model/wifi-mac.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-mac.h	2021-10-01 13:26:48.000000000 -0700
@@ -55,7 +55,8 @@
 {
   WIFI_MAC_DROP_FAILED_ENQUEUE = 0,
   WIFI_MAC_DROP_EXPIRED_LIFETIME,
-  WIFI_MAC_DROP_REACHED_RETRY_LIMIT
+  WIFI_MAC_DROP_REACHED_RETRY_LIMIT,
+  WIFI_MAC_DROP_QOS_OLD_PACKET
 };
 
 /**
